//Author: Ian Goodfellow
//todo-- add full lasik header

#include "svlDevel.h"


void usage()
{
  cout << "./extractorCat -o <outputFilename.xml> inputFile1 inputFile2 inputFile3 ... " << endl;
  cout << "inputFiles describe feature extractors. Produces outputFile that defines a feature extractor that extracts all of the features from the inputFiles. This is a deep copy so it is safe to remove/delete the input files if you don't need them otherwise." << endl;
}

int main(int argc, char ** argv)
{
  
  vector<svlDetectorFeatureExtractor *> extractors;

  const char * fileOut = NULL;

  for (int i = 1; i < argc; i++)
    {
      if (!strcmp(argv[i],"-o"))
	{
	  i++;

	  if (i == argc)
	    {
	      usage();
	      SVL_LOG(SVL_LOG_FATAL, "Argument list ends after -o");
	    }

	  fileOut = argv[i];
	}
      else
	{
	  string filename = string(argv[i]);
	  extractors.push_back(svlDetectorFeatureExtractor::getInstance(filename));
	  if (! extractors.back())
	    {
	      usage();
	      SVL_LOG(SVL_LOG_FATAL, "Could not open file \""<<filename<<"\"");
	    }
	  
	}
    }


  if (!fileOut)
    {
      usage();
      SVL_LOG(SVL_LOG_FATAL,"The -o argument is required");
    }

  svlCompositeFeatureExtractor * result = new svlCompositeFeatureExtractor(extractors);

  assert(result);


  result->write(fileOut);


  return 0;
}
